module KoL.Connection where

import Network.URI
import KoL.Util
import KoL.UtilTypes
import Control.Exception (throwIO)
import Control.Monad

-- TODO: Remove all these?

getUriPage url ref = do
	x <- join $ (processPage ref) ref (mkuri url) Nothing
	case x of
		Right (body, uri) -> return (body, uri)
		Left (body, uri) -> return (body, uri)

getPageRawNoScripts url ref = do
	(body, goturi, _) <- join $ (rawRetrievePage ref) ref (mkuri url) Nothing
	if ((uriPath goturi) == (uriPath $ mkuri url))
		then return body
		else do
			if uriPath goturi == "/login.php" || uriPath goturi == "/maint.php"
				then throwIO $ NotLoggedInException
				else do
					putStrLn $ "got uri: " ++ (show goturi) ++ " when raw-getting " ++ (url)
					throwIO $ UrlMismatchException url goturi

nochangeGetPageRawNoScripts url ref = do
	(body, goturi, _) <- join $ (nochangeRawRetrievePageFunc ref) ref (mkuri url) Nothing False
	if ((uriPath goturi) == (uriPath $ mkuri url))
		then return body
		else do
			if uriPath goturi == "/login.php" || uriPath goturi == "/maint.php"
				then throwIO $ NotLoggedInException
				else do
					putStrLn $ "got uri: " ++ (show goturi) ++ " when raw-getting " ++ (url)
					throwIO $ UrlMismatchException url goturi

postUriPage url params ref = do
	x <- join $ (processPage ref) ref (mkuri url) (Just params)
	case x of
		Right (body, uri) -> return (body, uri)
		Left (body, uri) -> return (body, uri)

postPage url params ref =  do
	(body, goturi) <- postUriPage url params ref
	if ((uriPath goturi) == (uriPath $ mkuri url))
		then return body
		else do
			putStrLn $ "got uri: " ++ (uriPath goturi) ++ " when posting " ++ (uriPath $ mkuri url)
			throwIO $ UrlMismatchException url goturi
